/*
 * DownLoadServlet.java
 *
 * Created on 2007/05/15, 16:50
 *
 * To change this template, choose Tools | Template Manager
 * and open the template in the editor.
 */

package org.itscool.weber.controller;

import java.io.FileInputStream;
import java.io.IOException;
import javax.servlet.ServletConfig;
import javax.servlet.ServletContext;
import javax.servlet.ServletException;
import javax.servlet.ServletOutputStream;
import javax.servlet.http.HttpServlet;
import javax.servlet.http.HttpServletRequest;
import javax.servlet.http.HttpServletResponse;

/**
 *
 * @author ios
 */
public class DownLoadServlet extends HttpServlet{
    protected ServletContext context = null;
    
    public void init(ServletConfig config) throws ServletException {
        context = config.getServletContext();
    }
    
    public void doGet(HttpServletRequest request,
            HttpServletResponse response) throws ServletException, IOException {
        String path = context.getRealPath(request.getServletPath());
        
        //ファイルのダウンロード
        // 
        //クライアントにファイルのダウンロードさせるサンプルです。
        //ブラウザではいきなりファイルが開くのではなく、「保存」するか「開く」か
        //を選択してもらうダイアログが表示されます。
        FileInputStream fi = new FileInputStream(path);
        byte[] b = new byte[fi.available()];
        for (int i = 0; i < b.length; i++)
            b[i] = (byte)fi.read();
        response.setContentType("application/octet-stream; charset=Shift_JIS");
        //response.setHeader("Content-Disposition","attachment; filename=\"" + path + "\"");
        response.setHeader("Content-Disposition","attachment;");
        response.setContentLength(b.length);
        try{
            ServletOutputStream os = response.getOutputStream();
            os.write(b);
            os.close();
        }catch(Exception e){
            e.printStackTrace();
        }
        fi.close();
    }
    
}
